! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module omphkgen_mod
  use dal
  use param
  use errorHandling
  implicit none
contains
  
  subroutine omphkgen

  character(len=1024) :: filter, filename
  logical :: twixel

  type(DataSetT) :: hkSet
  type(TableT) :: hkTable
  type(ColumnT) :: hkColumn
  integer :: i
  character(len=10) :: filterid(0:10)
  data filterid / "WHITE", "GRISM2", "UVW1", "UVM2", "UVW2", "GRISM1", "BLOCKED", "V", "MAGNIFIER", "U", "B" /


  integer(kind=int8), pointer :: param44(:)
  integer(kind=int16), pointer :: h5265(:)
  integer(kind=int32), pointer :: param48(:)

  !! added by GV -- 1998 November 24
  filename = stringParameter("phkf")
  filter = stringParameter("filter")
  twixel = booleanParameter("twixel")
  !!

  i = len_trim(filename)

  hkSet = dataSet(filename, create)
  call setAttribute(hkSet,"FILENAME",filename(i-30:i))

  hkTable = addTable(hkSet, "OMPEH1", 1)

  hkColumn = addColumn(hkTable, "PARAM44", integer8)
  param44 => int8data(hkColumn)
  if (twixel) then
     param44(0) = 0
  else
     param44(0) = 4
  endif
  call release(hkColumn)

  hkColumn = addColumn(hkTable, "PARAM48", integer32)
  param48 => int32data(hkColumn)
  i = 0
  do while(trim(filterid(i)) /= trim(filter)) 
     i = i + 1
  enddo
  i = i * 200
  param48(0) = i
  call release(hkColumn)

  hkColumn = addColumn(hkTable, "H5265", integer16)
  h5265 => int16data(hkcolumn)
  h5265(0) = 1400
  call release(hkColumn)

  hkColumn = addColumn(hkTable, "H5215", STRING, dimensions = (/ 12 /))
  call setStringCell(hkColumn,0,"HI RES WIN")
  call release(hkColumn)

  hkColumn = addColumn(hkTable, "TIME", STRING, dimensions = (/ 19 /))
  call setStringCell(hkColumn,0,"2000-01-01T00:00:00")
  call release(hkColumn)


  call release(hkTable)
  call release(hkSet)
end subroutine omphkgen
end module omphkgen_mod
