// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
// A class to manage ODF constituent information.
//
// 1998, Giuseppe Vacanti (XMM-SOC ESA)
//

#ifndef OdfConstituent_H
#define OdfConstituent_H

#include <string>


enum FileType {science, auxiliary, housekeeping, spacecraft, summary};

class OdfConstituent {
  
 public:
  
  OdfConstituent();
  OdfConstituent(string fname);
  
  string name() const;
  string revolution() const;
  string observation() const;
  string proposal() const;
  string proposal_exposure() const;
  string instrument() const;
  string scheduled() const;
  string exposure() const;
  string sux_exposure() const;
  string ccd() const;
  string data() const;
  string type() const;
  string base_name() const;
  string dir_name() const;
  
  bool is_slew() const;

  FileType file_type() const;
  
 private:
  
  string _name;
  
};

#endif
